#include "kk2f/KK2f/tauola.h"

      Subroutine BOOSTVERTICES
******-****************************************************************-*******
* 
*
*..Description:  Load old STDHEP used inside KoralB into new STDHEP /HEPEVT/.
*                Problem was that double precision PHEP was used in 
*                arguments inside KoralB code.  This is a reasonable cludge.
*
*  1/13/03 : Above description is outdated.
* SwB : kk2f works on standard hepevt (double precision)
*
*
*..Author:       J. Frederic Kral
*..History:
*    Kral      6/07/96 - First version.
*    Swagato Banerjee : 1/13/03 : cleanup code
*
*    Tau decay vertex position 
*
******-****************************************************************-*******
      Implicit none
*..Include:
#include "stdhep/stdhep.inc"
     
      COMMON / PARMAS / AMTAU,AMNUTA,AMEL,AMNUE,AMMU,AMNUMU
     *                 ,AMPIZ,AMPI,AMRO,GAMRO,AMA1,GAMA1
     *                 ,AMK,AMKZ,AMKST,GAMKST
C
      REAL*4            AMTAU,AMNUTA,AMEL,AMNUE,AMMU,AMNUMU
     *                 ,AMPIZ,AMPI,AMRO,GAMRO,AMA1,GAMA1
     *                 ,AMK,AMKZ,AMKST,GAMKST

*..Input:
*     None
*..Output:
*     None
*..Local:
      Integer*4 xn, n           ! used to avoid "No path to this statement"
      Integer*4 i,j             ! loop indexes

      integer tflag(100), itau1, itau2
      real dum, ctautau, fact1, fact2
      real vsx(2), vsy(2), vsz(2)
      
      real begran
      external begran

*=====-================================================================-=======

C  Secondary vertex positions for taus in Koralb        PCK  3/17/98
C  
C
c Abi: Initialize itau1/2 to remove linux warning:
      itau1 = 0
      itau2 = 0

      DO I=1,NHEP
        IF(IDHEP(I).EQ. 15)   ITAU1 = I          ! e-
        IF(IDHEP(I).EQ.-15)   ITAU2 = I          ! e+
      ENDDO

c Abi: If not generating taus, return:
      if (itau1 .eq. 0 .or. itau2 .eq. 0) then
         return
      endif

c Otherwise, shift tau daughter vertices:

      ctautau = 0.0872  !87.2 micron   Hard-wired for now.   
                        !Will use EvtGen decay.dec in the future.
                              
C-bug fix: get the sign of the decay vertex dist. right.  (pck 8/9/99)
C

      fact1 = (-1.)*alog(max(begran(dum),1.E-4)) * ctautau / amtau
      fact2 = (-1.)*alog(max(begran(dum),1.E-4)) * ctautau / amtau

      VSX(1) = fact1 * PHEP(1,ITAU1)
      VSY(1) = fact1 * PHEP(2,ITAU1)
      VSZ(1) = fact1 * PHEP(3,ITAU1)
      VSX(2) = fact2 * PHEP(1,ITAU2)
      VSY(2) = fact2 * PHEP(2,ITAU2)
      VSZ(2) = fact2 * PHEP(3,ITAU2)

C Determine which tau each particle originated from.

      CALL VZERO(TFLAG,NHEP)
      TFLAG(ITAU1) = 1
      TFLAG(ITAU2) = 2
      DO I=1,NHEP
        IF(ISTHEP(I).EQ.2.AND.TFLAG(I).NE.0) THEN
          DO J=JDAHEP(1,I),JDAHEP(2,I)
            TFLAG(J) = TFLAG(I)
          ENDDO
        ENDIF                
      ENDDO

C Abi: Shift only vertices of tau daughters, not the taus themselves:
      TFLAG(ITAU1) = 0
      TFLAG(ITAU2) = 0
C End Abi

      DO I=1,NHEP
        IF(TFLAG(I).NE.0) THEN
          VHEP(1,I) = VHEP(1,I) + VSX(TFLAG(I))
          VHEP(2,I) = VHEP(2,I) + VSY(TFLAG(I))
          VHEP(3,I) = VHEP(3,I) + VSZ(TFLAG(I))
c Abi: Move the production time so that boosting to the lab works right:
          IF(TFLAG(I).eq.1) THEN
             VHEP(4,I) = VHEP(4,I) + fact1 * PHEP(4, ITAU1)
          ELSEIF(TFLAG(I).eq.2) THEN 
             VHEP(4,I) = VHEP(4,I) + fact2 * PHEP(4, ITAU2)
          ENDIF
c End Abi
        ENDIF
      ENDDO

 999  return
      END
